<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Document</title>
</head>
<body onload="onPageLoading()">
    <div class="container">
        <p class="h3 text-center mt-5">Order Detail</p>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Order Code</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-ordercode">
            </div>
            <div class="col-2 text-right">
                <label>Cỡ combo</label>
            </div>
            <div class="col-4">
                <select id="select-size" class="form-control">
                    <option value="NOT_SELECT_COMBO">Chọn cỡ combo</option>
                    <option value="S">Nhỏ</option>
                    <option value="M">Vừa</option>
                    <option value="L">Lớn</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Đường kính pizza</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-duongkinh">
            </div>
            <div class="col-2 text-right">
                <labe>Sườn nướng (miếng)</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-suon-nuong">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Đồ uống</labe>
            </div>
            <div class="col-4">
                <select id="select-drink" class="form-control">
                    <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
                </select>
            </div>
            <div class="col-2 text-right">
                <labe>Số lượng nước uống</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-number-drink">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Voucher ID</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-voucherID">
            </div>
            <div class="col-2 text-right">
                <labe>Loại pizza</labe>
            </div>
            <div class="col-4">
                <select id="select-pizza" class="form-control">
                    <option value="NOT_SELECT_PIZZA">Chọn loại pizza</option>
                    <option value="Seafood">Hải sản</option>
                    <option value="Hawaii">Hawaii</option>
                    <option value="Bacon">Thịt hun khói</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Salad</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-salad">
            </div>
            <div class="col-2 text-right">
                <labe>Thành tiền</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-price">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Giảm giá</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-giam-gia">
            </div>
            <div class="col-2 text-right">
                <labe>Họ và tên</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-fullname">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Email</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-email">
            </div>
            <div class="col-2 text-right">
                <labe>Số điện thoại</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-phone-number">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Địa chỉ</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-address">
            </div>
            <div class="col-2 text-right">
                <labe>Lời nhắn</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-message">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Trạng thái đơn hàng</labe>
            </div>
            <div class="col-4">
                <select id="select-status" class="form-control">
                    <option value="NOT_SELECT_Status">Trạng thái</option>
                    <option value="open">Open</option>
                    <option value="confirmed">Confirm</option>
                    <option value="cancel">Cancel</option>
                </select>
            </div>
            <div class="col-2 text-right">
                <labe>Ngày tạo đơn</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-create-order-date">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <labe>Ngày cập nhập</labe>
            </div>
            <div class="col-4">
                <input class="form-control" id="inp-update-date">
            </div>
            <div class="col-2 text-right">
            </div>
            <div class="col-4">
                <button class="btn btn-group btn-success" id="btn-confirm">
                    Confirm
                </button>
                <button class="btn btn-group btn-info" id="btn-cancel">
                    Cancel
                </button>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */ 
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    var gId;
    var gOrderCode;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        //b1 doc du lieu
        var vUrlString = window.location.href; //đường dẫn gọi đến trang
        console.log(vUrlString);
        //tạo đối tượng url để truy vấn tham số 
        var vUrl = new URL(vUrlString);
        //truy vấn
        gId = vUrl.searchParams.get("id"); //set giá trị cho biến toàn cục gId
        gOrderCode = vUrl.searchParams.get("orderCode"); //set giá trị cho biến toàn cục gOrderCode
        //bước 2 validate
        const vFORM_LIST_VIEW = "index.html";
        if(gId == null || gId == ""){
            alert("Không có id của đơn hàng");
            window.location.href = vFORM_LIST_VIEW;
        }
        console.log("id: " + gId);
        console.log("Order code (mã đơn hàng): " + gOrderCode);
        //load dữ liệu drink
        loadDataDrinkList();
        //b3 goi server
        //goi api thông tin đơn hàng (order)
        var vXmlHttp = new XMLHttpRequest();
        callApiOrderData(vXmlHttp,gOrderCode);
        //hàm xử lý thông tin responsertext trả về
        vXmlHttp.onreadystatechange = function(){
            if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                //b4 hiển thị lên form
                showDataForm(vXmlHttp);
            }
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //thêm paramOrderCode để lấy đúng order chi tiết của đơn vừa bấm
    function callApiOrderData(paramXmlHttp,paramOrderCode){
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        paramXmlHttp.open("GET",vBASE_URL + "/" + paramOrderCode,true);
        paramXmlHttp.send();
    }
    function showDataForm(paramXmlHttp){
        "use strict";
        console.log(paramXmlHttp.responseText); // hiển thị ra chuỗi json của order chi tiết vừa click
        //parse du lieu thanh object
        var vOrderDataObj = JSON.parse(paramXmlHttp.responseText);
        var vOrderCode = document.getElementById("inp-ordercode");
        var vCombo = document.getElementById("select-size");
        var vDuongKinhPizza = document.getElementById("inp-duongkinh");
        var vDrink = document.getElementById("select-drink");
        var vSoLuongDoUong = document.getElementById("inp-number-drink");
        var vPizzaType = document.getElementById("select-pizza");
        var vSaladType = document.getElementById("inp-salad");
        var vThanhTien = document.getElementById("inp-price");
        var vVoucherID = document.getElementById("inp-voucherID");
        var vSuonNuong = document.getElementById("inp-suon-nuong");
        var vGiamGia = document.getElementById("inp-giam-gia");
        var vName = document.getElementById("inp-fullname");
        var vEmail = document.getElementById("inp-email");
        var vAddress = document.getElementById("inp-address");
        var vPhoneNumber = document.getElementById("inp-phone-number");
        var vMessage = document.getElementById("inp-message");
        var vTrangThaiDonHang = document.getElementById("select-status");
        var vNgayTaoDon = document.getElementById("inp-create-order-date");
        var vNgayCapNhap = document.getElementById("inp-update-date");

        vOrderCode.value = vOrderDataObj.orderCode;
        vCombo.value = vOrderDataObj.kichCo;
        vDuongKinhPizza.value = vOrderDataObj.duongKinh;
        vDrink.value = vOrderDataObj.idLoaiNuocUong;
        vSoLuongDoUong.value = vOrderDataObj.soLuongNuoc;
        vPizzaType.value = vOrderDataObj.loaiPizza;
        vSaladType.value = vOrderDataObj.salad;
        vSuonNuong.value = vOrderDataObj.suon;
        vThanhTien.value = vOrderDataObj.thanhTien;
        vVoucherID.value = vOrderDataObj.idVourcher;
        vGiamGia.value = vOrderDataObj.giamGia;
        vName.value = vOrderDataObj.hoTen;
        vEmail.value = vOrderDataObj.email;
        vAddress.value = vOrderDataObj.diaChi;
        vPhoneNumber.value = vOrderDataObj.soDienThoai;
        vMessage.value = vOrderDataObj.loiNhan;
        vTrangThaiDonHang.value = vOrderDataObj.trangThai;
        vNgayTaoDon.value = vOrderDataObj.ngayTao;
        vNgayCapNhap.value = vOrderDataObj.ngayCapNhat; 
    }
    function loadDataDrinkList(){
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET",vBASE_URL,true);
        vXmlHttp.send();
        vXmlHttp.onreadystatechange = function(){
            if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                console.log(vXmlHttp.responseText);// ghi response text ra console log
                handleDataToSelectDrink(vXmlHttp);
            }
        }
    }

    function handleDataToSelectDrink(paramXmlHttp){
        var vArrayListDrink = JSON.parse(paramXmlHttp.responseText);
        console.log("array link list = "+ vArrayListDrink.length);
        //load data to drink select web
        var vElementSelectDrink = document.getElementById("select-drink");
        for (var bI=0; bI<vArrayListDrink.length; bI ++){
            var vDrinkOptionElement = document.createElement("option");
            vDrinkOptionElement.value = vArrayListDrink[bI].maNuocUong;
            vDrinkOptionElement.text = vArrayListDrink[bI].tenNuocUong;
            vElementSelectDrink.appendChild(vDrinkOptionElement);
        }
    }
</script>
</html>